/*
 * i2c_test.c
 *
 *  Created on: Jun 18, 2015
 *      Author: makoto
 */


#include <msp430.h>
#include "bucket.h"
#include "i2c_com.h"
#include "i2c_test.h"
#include "dec2hex.h"
#include "focal_stack.h"

extern unsigned char TxBuffer[BUFFER_LENGTH];
extern unsigned char *PTxData;                     // Pointer to TX data
extern unsigned char RxBuffer[BUFFER_LENGTH];       // Allocate 128 byte of RAM
#define __IRQ_WAIT


unsigned char *PTxData;                     // Pointer to TX data
extern unsigned char TXByteCtr;

const unsigned char TxDataTmp[] =              // Table of data to transmit
{
  'a',
  'b',
  'c',
  'd',
  'e',
  'f',
  'g',
  'h',
  'i',
  'j',
  'k',
  'l',
  'm',
  'n',
  'o',
  'p',
  'q',
  'r',
  'a',
  't',
  'u',
  'v',
  'w',
  'x',
  'y',
  'z',
  'A',
  'B',
  'C',
  'D',
  'E',
  'F',
  'G',
  'H',
  'I',
  'J',
  'K',
  'L',
  'M',
  'N',
  'O'
};



/*
Wire.write('<');
Wire.write('8');
Wire.write('7');
Wire.write(' ');

Wire.write('4');
Wire.write('>');

Wire.write(0xd);
*/

int i2c_led_driver_test(void)
{
int i;
const unsigned char TxDataTmp[] =              // Table of data to transmit
{
  0x11,
  0x00,/*prescaler*/
  0xF0,/**/
  0x05,
  0xe0,
  0xAA, /*0xAA*/
};

    // Initialize i2c
	init_i2c_UCB0();

	while (1)
	  {
//		read_i2c(I2C_ADDR_EXPANDER,6);
		write_i2c(I2C_ADDR_STROBE,sizeof TxDataTmp,(unsigned char *)TxDataTmp);
		i++;
	  }

	return 0;

}


int i2c_write_long_test(void)
{
int i;


    // Initialize i2c
	init_i2c_UCB0();

	while (1)
	  {
		read_i2c(I2C_ADDR_EXPANDER,9);
		write_i2c(I2C_ADDR_EXPANDER,sizeof TxDataTmp,(unsigned char *)TxDataTmp);
		i++;
	  }

	return 0;

}





int i2c_master_tx_test(void)
{
int i=0;

    // Initialize i2c
	init_i2c_UCB0();

	while (1)
	  {
		write_i2c(I2C_ADDR_EXPANDER+(i%3),sizeof TxDataTmp,(unsigned char *)TxDataTmp);
		i++;
	  }

	return 0;

}

extern unsigned char *SlavePRxData;                     // Pointer to RX data
extern unsigned char SlaveRXByteCtr;



// 091615
int i2c_slave_rx_test(void)
{

	  init_i2c_UCB1();

	  while (1)
	  {
		  i2c_slave_rx();
	  }                                         // read out the RxData buffer
	return 0;

}


int i2c_slave_tx_test(void)
{
	init_i2c_UCB0();                                          // Enable TX interrupt

    TxBuffer[0]=8;
    TxBuffer[1]=9;
    TxBuffer[2]=0xAA;
	  while (1)
	  {
	    PTxData = (unsigned char *)TxBuffer;      // Start of TX buffer

	    __bis_SR_register(LPM0_bits + GIE);     // Enter LPM0, enable interrupts
	                                            // Remain in LPM0 until master
	                                            // finishes RX
	    __no_operation();                       // Set breakpoint >>here<< and
	  }                                         // read out the TXByteCtr counter

}

int i2c_master_rx_test(void)
{
    // Initialize i2c
	init_i2c_UCB1();

	__bis_SR_register( 0);
	volatile int enable_address;

	enable_address=scan_i2c(MAX_NUM_SCAN_DOWNSTREAM);


	 volatile int i,rd,ack;
	 	rd=0;
		ack=read_i2c(I2C_ADDR_MCU,9);
		rd=RxBuffer[0];

		if(rd!=8)
		{
		    __no_operation();
		}

	return 0;

}


int i2c_master_rx_test_i2c_exp(void)
{
	   // Initialize i2c
		init_i2c_UCB0();

	__bis_SR_register( 0);
	volatile int enable_address;

	while(1)
	{
	read_i2c(0x20,1);
	}
	return 0;

}
