/*
 * focal_stack.h
 *
 *  Created on: Sep 25, 2015
 *      Author: makoto
 */

#ifndef FOCAL_STACK_H_
#define FOCAL_STACK_H_

void linear_actuator_reciprocating_test();
void linear_actuator_debug_via_com();


void linear_actuator_calibrate_motor();
void linear_actuator_set_travel_limits(int,int);
void linear_actuator_move_target(int);
int linear_actuator_get_status();

void linear_actuator_set_position(int);
void linear_actuator_set_speed(int,int,int);




int linear_actuator_get_position();

int get_linear_step(int ,int ,int );


int hex2dec( unsigned char);
unsigned int hex2dec_multiple(unsigned char *);

#define LENGTH_LINEAR_ACTUATOR_COM10 30
#define CARRIAGE_RETURN_LINEAR_ACTUATOR 0xD
#define LENGTH_LINEAR_ACTUATOR_COM87 15
#define LENGTH_LINEAR_ACTUATOR_COM6 5
#define LENGTH_LINEAR_ACTUATOR_COM8 5
#define LENGTH_LINEAR_ACTUATOR_COM40 5
#define LENGTH_LINEAR_ACTUATOR_COM46 28
#endif /* FOCAL_STACK_H_ */
